<template>
    <div v-if="!nameUser" class="loading-container"><img src="../../../../public/assets/loading.gif"></div>
    <div v-else class="contenedor-principal">
        <div class="bienvenida-container">
          <h1 style="flex: 1;">Bienvenido {{ nameUser }}</h1>
          <svg-icon @click="onLogout" type="mdi" :path="path" style="cursor: pointer;"></svg-icon>
        </div>
        <div class="contenedor-main">
          <div class="ranking"><Ranking :ranking="ranking"/></div>
          <div class="game"><Game/>
              <div>
                  <router-view></router-view>
              </div>
          </div>
          <div class="data"><DataUser :rankingUser="rankingUser"/></div>
        </div>
      </div>
  </template>
    
    <script>
    import useUsers from '@/composables/useUsers'
    import usePoints from "@/composables/usePoints";
    import SvgIcon from '@jamescoyle/vue-icon';
    import { mdiLogout } from '@mdi/js';
    import { useRouter, onBeforeRouteUpdate } from 'vue-router';
  import { defineAsyncComponent, ref } from 'vue';
    
    export default {
      components: {
        SvgIcon,
        Ranking: defineAsyncComponent(() => import('@/modules/home/components/Ranking.vue')),
        Game: defineAsyncComponent(() => import('@/modules/home/components/Game.vue')),
        DataUser: defineAsyncComponent(() => import('@/modules/home/components/Data.vue'))
      },
      setup(){
        
        const { nameUser, logout } = useUsers()
        const { listRanking, dataPointsUser } = usePoints();
        const router = useRouter()
        const ranking = ref(null);
        const rankingUser = ref(null);

        onBeforeRouteUpdate( async (to, from, next) => {

          const { dataUser: rankingData } = await listRanking();
          ranking.value = rankingData

          const { dataUser: pointsUserData } = await dataPointsUser(nameUser.value);
          rankingUser.value = pointsUserData
          next();
        })

        /*onBeforeRouteUpdate( async (to, from, next) => {

          const { dataUser } = await dataPointsUser(nameUser);
          ranking.value = dataUser
          next();
        })*/
    
        return{
          
          nameUser,
          path: mdiLogout,
  
          onLogout: () => {
  
            router.push({name: 'login'})
            logout()
          },
          ranking,
          rankingUser
        }
      }
    }
    </script>
    
  <style scoped>
    @import url('../css/main.css'); 
    @import url('../css/home.css');
  </style>